<?xml version = "1.0" encoding = "UTF-8"?>

<!--
    MDDL - Market Data Definition Language
    Version 2.0-beta 15 September 2002
    Copyright (c)2001-2002, The Software & Information Industry Association.
    See http://www.mddl.org/ or http://www.fisd.net/mddl/
-->

<xsl:transform
    xmlns:xsl = "http://www.w3.org/1999/XSL/Transform" version = "1.0"
    xmlns:mdref = "http://www.mddl.org/mddl/2002/2.0-beta/ref"
    xmlns:xlink = "http://www.w3.org/1999/xlink"
    xmlns:xsd = "http://www.w3.org/2001/XMLSchema">
	<xsl:import href = "mddl-2.0-beta-validate.xsl"/>
	<xsl:output method = "xml" indent = "yes" version = "1.0" encoding = "utf-8"/>
	<xsl:param name = "targetNamespace" select = "'http://www.mddl.org/mddl/2002/2.0-beta'"/>
	<xsl:variable name = "space" select = "' '"/>
	<xsl:template match = "/">
		<!-- xsl:apply-templates select = "/mddl-schema" mode = "validate"/ -->
		<xsl:element name = "xsd:schema">
			<xsl:attribute name = "targetNamespace">
				<xsl:value-of select = "concat($targetNamespace, '/ref')"/>
			</xsl:attribute>
			<xsl:attribute name = "elementFormDefault">
				<xsl:text>qualified</xsl:text>
			</xsl:attribute>
			<xsl:attribute name = "attributeFormDefault">
				<xsl:text>unqualified</xsl:text>
			</xsl:attribute>
			<xsl:element name = "xsd:import">
				<xsl:attribute name = "namespace">
					<xsl:text>http://www.w3.org/1999/xlink</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "schemaLocation">
					<xsl:text>mddllink-2.0-beta.xsd</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:element name = "xsd:import">
				<xsl:attribute name = "namespace">
					<xsl:text>http://www.w3.org/XML/1998/namespace</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "schemaLocation">
					<xsl:text>xml.xsd</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:apply-templates select = "//*[@name][not(self::attribute)]" mode = "w3c-schema-mdref">
				<xsl:sort select = "@name"/>
			</xsl:apply-templates>
			<!-- MDDL reference definitions -->
			<xsl:element name = "xsd:group">
				<xsl:attribute name = "name">
					<xsl:text>mdRefType.model</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:choice">
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mdref:delete</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mdref:replace</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mdref:addChildrenOf</xsl:text>
						</xsl:attribute>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:complexType">
				<xsl:attribute name = "name">
					<xsl:text>mdRefType</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:group">
					<xsl:attribute name = "ref">
						<xsl:text>mdref:mdRefType.model</xsl:text>
					</xsl:attribute>
					<xsl:attribute name = "minOccurs">
						<xsl:value-of select = "number(0)"/>
					</xsl:attribute>
					<xsl:attribute name = "maxOccurs">
						<xsl:text>unbounded</xsl:text>
					</xsl:attribute>
				</xsl:element>
				<xsl:element name = "xsd:attribute">
					<xsl:attribute name = "ref">
						<xsl:text>xlink:type</xsl:text>
					</xsl:attribute>
					<!-- [ABC] Xerces doesn't like seeing fixed values restated.
					<xsl:attribute name = "fixed">
						<xsl:text>simple</xsl:text>
					</xsl:attribute>
					-->
				</xsl:element>
				<xsl:element name = "xsd:attribute">
					<xsl:attribute name = "ref">
						<xsl:text>xlink:href</xsl:text>
					</xsl:attribute>
					<xsl:attribute name = "use">
						<xsl:text>required</xsl:text>
					</xsl:attribute>
				</xsl:element>
				<xsl:element name = "xsd:attribute">
					<xsl:attribute name = "ref">
						<xsl:text>xlink:role</xsl:text>
					</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>delete</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>replace</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType">
					<xsl:element name = "xsd:sequence">
						<xsl:element name = "xsd:any">
							<xsl:attribute name = "namespace">
								<xsl:value-of select = "$targetNamespace"/>
							</xsl:attribute>
							<xsl:attribute name = "processContents">
								<xsl:text>strict</xsl:text>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
					<xsl:element name = "xsd:attribute">
						<xsl:attribute name = "ref">
							<xsl:text>xlink:href</xsl:text>
						</xsl:attribute>
						<xsl:attribute name = "use">
							<xsl:text>required</xsl:text>
						</xsl:attribute>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>addChildrenOf</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType">
					<xsl:element name = "xsd:sequence">
						<xsl:element name = "xsd:any">
							<xsl:attribute name = "namespace">
								<xsl:value-of select = "$targetNamespace"/>
							</xsl:attribute>
							<xsl:attribute name = "processContents">
								<xsl:text>strict</xsl:text>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
					<xsl:element name = "xsd:attribute">
						<xsl:attribute name = "ref">
							<xsl:text>xlink:href</xsl:text>
						</xsl:attribute>
						<xsl:attribute name = "use">
							<xsl:text>required</xsl:text>
						</xsl:attribute>
					</xsl:element>
				</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "element[@name]" mode = "w3c-schema-mdref"/>
	<xsl:template match = "domain[@name]" mode = "w3c-schema-mdref">
		<xsl:call-template name = "build-mdref">
			<xsl:with-param name = "elementName">
				<xsl:value-of select = "concat(@name, 'Domain')"/>
			</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name = "build-mdref">
			<xsl:with-param name = "elementName">
				<xsl:value-of select = "concat(@name, 'DomainGroup')"/>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
	<xsl:template match = "class[@name]" mode = "w3c-schema-mdref">
		<xsl:call-template name = "build-mdref">
			<xsl:with-param name = "elementName">
				<xsl:value-of select = "concat(@name, 'Class')"/>
			</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name = "build-mdref">
			<xsl:with-param name = "elementName">
				<xsl:value-of select = "concat(@name, 'ClassGroup')"/>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
	<xsl:template match = "subclass[@name]" mode = "w3c-schema-mdref">
		<xsl:call-template name = "build-mdref">
			<xsl:with-param name = "elementName">
				<xsl:value-of select = "concat(@name, 'Subclass')"/>
			</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name = "build-mdref">
			<xsl:with-param name = "elementName">
				<xsl:value-of select = "concat(@name, 'SubclassGroup')"/>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
	<xsl:template match = "property[@name]" mode = "w3c-schema-mdref">
		<xsl:call-template name = "build-mdref">
			<xsl:with-param name = "elementName">
				<xsl:value-of select = "@name"/>
			</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name = "build-mdref">
			<xsl:with-param name = "elementName">
				<xsl:value-of select = "concat(@name, 'Group')"/>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
	<xsl:template match = "group" mode = "w3c-schema-mdref"/>
	<xsl:template match = "attribute" mode = "w3c-schema-mdref"/>
	<xsl:template name = "build-mdref">
		<xsl:param name = "elementName"/>
		<xsl:element name = "xsd:element">
			<xsl:attribute name = "name">
				<xsl:value-of select = "$elementName"/>
			</xsl:attribute>
			<xsl:element name = "xsd:complexType">
				<xsl:element name = "xsd:complexContent">
					<xsl:element name = "xsd:restriction">
						<xsl:attribute name = "base">
							<xsl:text>mdref:mdRefType</xsl:text>
						</xsl:attribute>
						<xsl:element name = "xsd:group">
							<xsl:attribute name = "ref">
								<xsl:text>mdref:mdRefType.model</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "minOccurs">
								<xsl:value-of select = "number(0)"/>
							</xsl:attribute>
							<xsl:attribute name = "maxOccurs">
								<xsl:text>unbounded</xsl:text>
							</xsl:attribute>
						</xsl:element>
						<xsl:element name = "xsd:attribute">
							<xsl:attribute name = "ref">
								<xsl:text>xlink:type</xsl:text>
							</xsl:attribute>
							<!-- [ABC] Xerces doesn't like seeing fixed values restated.
							<xsl:attribute name = "fixed">
								<xsl:text>simple</xsl:text>
							</xsl:attribute>
							-->
						</xsl:element>
						<xsl:element name = "xsd:attribute">
							<xsl:attribute name = "ref">
								<xsl:text>xlink:href</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "use">
								<xsl:text>required</xsl:text>
							</xsl:attribute>
						</xsl:element>
						<xsl:element name = "xsd:attribute">
							<xsl:attribute name = "ref">
								<xsl:text>xlink:role</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "fixed">
								<xsl:value-of select = "concat($targetNamespace, '#', $elementName)"/>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>
</xsl:transform>