<?xml version = "1.0" encoding = "UTF-8"?>

<!--
    MDDL - Market Data Definition Language
    Version 2.0-beta 15 September 2002
    Copyright (c)2001-2002, The Software & Information Industry Association.
    See http://www.mddl.org/ or http://www.fisd.net/mddl/
-->

<xsl:transform
    xmlns:xsl = "http://www.w3.org/1999/XSL/Transform" version = "1.0"
    xmlns:mddl = "http://www.mddl.org/mddl/2002/2.0-beta"
    xmlns:mdref = "http://www.mddl.org/mddl/2002/2.0-beta/ref"
    xmlns:xlink = "http://www.w3.org/1999/xlink"
    xmlns:xsd = "http://www.w3.org/2001/XMLSchema">
	<xsl:import href = "mddl-2.0-beta-validate.xsl"/>
	<xsl:output method = "xml" indent = "yes" version = "1.0" encoding = "utf-8"/>
	<xsl:param name = "targetNamespace" select = "'http://www.mddl.org/mddl/2002/2.0-beta'"/>
	<xsl:param name = "buildLevel" select = "'full'"/>
	<xsl:variable name = "space" select = "' '"/>
	<xsl:key name = "propertiesByName" match = "property[@name]" use = "@name"/>
	<xsl:template match = "/">
		<!-- xsl:apply-templates select = "/mddl-schema" mode = "validate"/ -->
		<xsl:element name = "xsd:schema">
			<xsl:attribute name = "targetNamespace">
				<xsl:value-of select = "$targetNamespace"/>
			</xsl:attribute>
			<xsl:attribute name = "elementFormDefault">
				<xsl:text>qualified</xsl:text>
			</xsl:attribute>
			<xsl:attribute name = "attributeFormDefault">
				<xsl:text>unqualified</xsl:text>
			</xsl:attribute>
			<xsl:element name = "xsd:import">
				<xsl:attribute name = "namespace">
					<xsl:value-of select = "concat($targetNamespace, '/ref')"/>
				</xsl:attribute>
				<xsl:attribute name = "schemaLocation">
					<xsl:text>mddlref-2.0-beta.xsd</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:element name = "xsd:import">
				<xsl:attribute name = "namespace">
					<xsl:text>http://www.w3.org/1999/xlink</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "schemaLocation">
					<xsl:text>mddllink-2.0-beta.xsd</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:element name = "xsd:import">
				<xsl:attribute name = "namespace">
					<xsl:text>http://www.w3.org/XML/1998/namespace</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "schemaLocation">
					<xsl:text>xml.xsd</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:apply-templates select = "//*[@name][not(self::attribute)]" mode = "w3c-schema-define">
				<xsl:sort select = "@name"/>
			</xsl:apply-templates>
			<xsl:comment>
				<xsl:text>MDDL simple data elements</xsl:text>
			</xsl:comment>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>mdString</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:string</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>mdDecimal</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:decimal</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>mdPercentage</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:decimal</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>mdInteger</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:integer</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>mdBoolean</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:boolean</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>mdDateTime</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:dateTime</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>mdDuration</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:duration</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>mdUri</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:anyURI</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:comment>
				<xsl:text>MDDL functions</xsl:text>
			</xsl:comment>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>plus</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>minus</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>times</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>dividedBy</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>sumOf</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType">
					<xsl:element name = "xsd:choice">
						<xsl:attribute name = "minOccurs">
							<xsl:value-of select = "number(1)"/>
						</xsl:attribute>
						<xsl:attribute name = "maxOccurs">
							<xsl:text>unbounded</xsl:text>
						</xsl:attribute>
						<xsl:element name = "xsd:group">
							<xsl:attribute name = "ref">
								<xsl:text>mddl:mathNode.model</xsl:text>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>productOf</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType">
					<xsl:element name = "xsd:choice">
						<xsl:attribute name = "minOccurs">
							<xsl:value-of select = "number(1)"/>
						</xsl:attribute>
						<xsl:attribute name = "maxOccurs">
							<xsl:text>unbounded</xsl:text>
						</xsl:attribute>
						<xsl:element name = "xsd:group">
							<xsl:attribute name = "ref">
								<xsl:text>mddl:mathNode.model</xsl:text>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:group">
				<xsl:attribute name = "name">
					<xsl:text>mathFunction.model</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:choice">
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:sumOf</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:productOf</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:otherFunction</xsl:text>
						</xsl:attribute>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:group">
				<xsl:attribute name = "name">
					<xsl:text>mathNode.model</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:choice">
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:mdMath</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:mdBoolean</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:mdInteger</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:mdDecimal</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:mdPercentage</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:mdDateTime</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:mdDuration</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:group">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:mathFunction.model</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:any">
						<xsl:attribute name = "namespace">
							<xsl:value-of select = "concat($targetNamespace, '/ref')"/>
						</xsl:attribute>
						<xsl:attribute name = "processContents">
							<xsl:text>strict</xsl:text>
						</xsl:attribute>
						<xsl:attribute name = "minOccurs">
							<xsl:value-of select = "number(1)"/>
						</xsl:attribute>
						<xsl:attribute name = "maxOccurs">
							<xsl:value-of select = "number(1)"/>
						</xsl:attribute>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:group">
				<xsl:attribute name = "name">
					<xsl:text>mathOperator.model</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:choice">
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:plus</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:minus</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:times</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:dividedBy</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:otherOperator</xsl:text>
						</xsl:attribute>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:complexType">
				<xsl:attribute name = "name">
					<xsl:text>mdMath.model</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:sequence">
					<xsl:element name = "xsd:group">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:mathNode.model</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:sequence">
						<xsl:attribute name = "minOccurs">
							<xsl:value-of select = "number(0)"/>
						</xsl:attribute>
						<xsl:attribute name = "maxOccurs">
							<xsl:value-of select = "number(1)"/>
						</xsl:attribute>
						<xsl:element name = "xsd:group">
							<xsl:attribute name = "ref">
								<xsl:text>mddl:mathOperator.model</xsl:text>
							</xsl:attribute>
						</xsl:element>
						<xsl:element name = "xsd:group">
							<xsl:attribute name = "ref">
								<xsl:text>mddl:mathNode.model</xsl:text>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>mdMath</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>mddl:mdMath.model</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:comment>
				<xsl:text>MDDL conditions</xsl:text>
			</xsl:comment>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>equalTo</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>lessThan</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>lessOrEqualTo</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>greaterThan</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>greaterOrEqualTo</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>notEqualTo</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType"/>
			</xsl:element>
			<xsl:element name = "xsd:group">
				<xsl:attribute name = "name">
					<xsl:text>mathComparison.model</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:choice">
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:equalTo</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:notEqualTo</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:lessThan</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:lessOrEqualTo</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:greaterThan</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:greaterOrEqualTo</xsl:text>
						</xsl:attribute>
					</xsl:element>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:otherComparison</xsl:text>
						</xsl:attribute>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>when</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType">
					<xsl:element name = "xsd:sequence">
						<xsl:element name = "xsd:group">
							<xsl:attribute name = "ref">
								<xsl:text>mddl:mathNode.model</xsl:text>
							</xsl:attribute>
						</xsl:element>
						<xsl:element name = "xsd:group">
							<xsl:attribute name = "ref">
								<xsl:text>mddl:mathComparison.model</xsl:text>
							</xsl:attribute>
						</xsl:element>
						<xsl:element name = "xsd:group">
							<xsl:attribute name = "ref">
								<xsl:text>mddl:mathNode.model</xsl:text>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:comment>
				<xsl:text>mddl:other, etc.</xsl:text>
			</xsl:comment>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>other</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType">
					<xsl:element name = "xsd:sequence">
						<xsl:element name = "xsd:any">
							<xsl:attribute name = "namespace">
								<xsl:text>##other</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "processContents">
								<xsl:text>skip</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "minOccurs">
								<xsl:value-of select = "number(0)"/>
							</xsl:attribute>
							<xsl:attribute name = "maxOccurs">
								<xsl:text>unbounded</xsl:text>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>otherComparison</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType">
					<xsl:element name = "xsd:sequence">
						<xsl:element name = "xsd:any">
							<xsl:attribute name = "namespace">
								<xsl:text>##other</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "processContents">
								<xsl:text>skip</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "minOccurs">
								<xsl:value-of select = "number(1)"/>
							</xsl:attribute>
							<xsl:attribute name = "maxOccurs">
								<xsl:value-of select = "number(1)"/>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>otherFunction</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType">
					<xsl:element name = "xsd:sequence">
						<xsl:element name = "xsd:any">
							<xsl:attribute name = "namespace">
								<xsl:text>##other</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "processContents">
								<xsl:text>skip</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "minOccurs">
								<xsl:value-of select = "number(1)"/>
							</xsl:attribute>
							<xsl:attribute name = "maxOccurs">
								<xsl:value-of select = "number(1)"/>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "name">
					<xsl:text>otherOperator</xsl:text>
				</xsl:attribute>
				<xsl:element name = "xsd:complexType">
					<xsl:element name = "xsd:sequence">
						<xsl:element name = "xsd:any">
							<xsl:attribute name = "namespace">
								<xsl:text>##other</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "processContents">
								<xsl:text>skip</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "minOccurs">
								<xsl:value-of select = "number(1)"/>
							</xsl:attribute>
							<xsl:attribute name = "maxOccurs">
								<xsl:value-of select = "number(1)"/>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:element>
			</xsl:element>
		</xsl:element>
		<xsl:message>
			<xsl:text>Done.</xsl:text>
		</xsl:message>
	</xsl:template>
	<xsl:template match = "element[@name]" mode = "w3c-schema-define">
		<xsl:element name = "xsd:complexType">
			<xsl:attribute name = "name">
				<xsl:value-of select = "concat(@name, '.model')"/>
			</xsl:attribute>
			<xsl:element name = "xsd:annotation">
				<xsl:element name = "xsd:appinfo">
					<xsl:element name = "mddl:schema-classification">
						<xsl:text>element</xsl:text>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:choose>
				<xsl:when test = "@type">
					<xsl:choose>
						<xsl:when test = "@type = 'content'">
							<xsl:element name = "xsd:choice">
								<xsl:attribute name = "minOccurs">
									<xsl:value-of select = "number(0)"/>
								</xsl:attribute>
								<xsl:attribute name = "maxOccurs">
									<xsl:text>unbounded</xsl:text>
								</xsl:attribute>
								<xsl:element name = "xsd:any">
									<xsl:attribute name = "namespace">
										<xsl:value-of select = "$targetNamespace"/>
									</xsl:attribute>
									<xsl:attribute name = "processContents">
										<xsl:text>strict</xsl:text>
									</xsl:attribute>
								</xsl:element>
							</xsl:element>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name = "error-message">
								<xsl:with-param name = "message">
									<xsl:text>unrecognised MDDL data type:</xsl:text>
									<xsl:value-of select = "$space"/>
									<xsl:value-of select = "@type"/>
								</xsl:with-param>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:element name = "xsd:sequence">
						<xsl:apply-templates select = "*" mode = "w3c-schema-ref"/>
						<xsl:if test = "not (@final) or (@final != 'true')">
							<xsl:element name = "xsd:element">
								<xsl:attribute name = "ref">
									<xsl:text>mddl:other</xsl:text>
								</xsl:attribute>
								<xsl:attribute name = "minOccurs">
									<xsl:value-of select = "number(0)"/>
								</xsl:attribute>
								<xsl:attribute name = "maxOccurs">
									<xsl:value-of select = "number(1)"/>
								</xsl:attribute>
							</xsl:element>
						</xsl:if>
					</xsl:element>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:element name = "xsd:attribute">
				<xsl:attribute name = "name">
					<xsl:text>id</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:ID</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "use">
					<xsl:text>optional</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:apply-templates select = "attribute" mode = "w3c-schema-local"/>
		</xsl:element>
		<xsl:element name = "xsd:element">
			<xsl:attribute name = "name">
				<xsl:value-of select = "@name"/>
			</xsl:attribute>
			<xsl:attribute name = "type">
				<xsl:value-of select = "concat('mddl:', @name, '.model')"/>
			</xsl:attribute>
			<xsl:element name = "xsd:annotation">
				<xsl:element name = "xsd:appinfo">
					<xsl:element name = "mddl:schema-classification">
						<xsl:text>element</xsl:text>
					</xsl:element>
				</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "element" mode = "w3c-schema-ref">
		<xsl:variable name = "refName">
			<xsl:choose>
				<xsl:when test = "@name">
					<xsl:value-of select = "@name"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select = "@ref"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name = "minCount">
			<xsl:choose>
				<xsl:when test = "parent::group[@method = 'repeatable-choice']">
					<xsl:value-of select = "number(1)"/>
				</xsl:when>
				<xsl:when test = "@use = 'required'">
					<xsl:value-of select = "number(1)"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select = "number(0)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:element name = "xsd:element">
			<xsl:attribute name = "ref">
				<xsl:value-of select = "concat('mddl:', normalize-space($refName))"/>
			</xsl:attribute>
			<xsl:attribute name = "minOccurs">
				<xsl:value-of select = "number($minCount)"/>
			</xsl:attribute>
			<xsl:attribute name = "maxOccurs">
				<xsl:value-of select = "number(1)"/>
			</xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "domain[@name]" mode = "w3c-schema-define">
		<xsl:element name = "xsd:complexType">
			<xsl:attribute name = "name">
				<xsl:value-of select = "concat(@name, 'Domain.model')"/>
			</xsl:attribute>
			<xsl:element name = "xsd:annotation">
				<xsl:element name = "xsd:appinfo">
					<xsl:element name = "mddl:schema-classification">
						<xsl:text>domain</xsl:text>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:sequence">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:when</xsl:text>
					</xsl:attribute>
					<xsl:attribute name = "minOccurs">
						<xsl:value-of select = "number(0)"/>
					</xsl:attribute>
					<xsl:attribute name = "maxOccurs">
						<xsl:value-of select = "number(1)"/>
					</xsl:attribute>
				</xsl:element>
				<xsl:if test = "count(*) >= 1">
					<xsl:element name = "xsd:choice">
						<xsl:attribute name = "minOccurs">
							<xsl:value-of select = "number(0)"/>
						</xsl:attribute>
						<xsl:attribute name = "maxOccurs">
							<xsl:text>unbounded</xsl:text>
						</xsl:attribute>
						<xsl:if test = "count(*) >= 1">
							<xsl:element name = "xsd:choice">
								<xsl:attribute name = "minOccurs">
									<xsl:value-of select = "number(1)"/>
								</xsl:attribute>
								<xsl:attribute name = "maxOccurs">
									<xsl:value-of select = "number(1)"/>
								</xsl:attribute>
								<xsl:element name = "xsd:element">
									<xsl:attribute name = "ref">
										<xsl:value-of select = "concat('mddl:', @name, 'DomainGroup')"/>
									</xsl:attribute>
								</xsl:element>
								<xsl:if test = "$buildLevel = 'full'">
									<xsl:element name = "xsd:element">
										<xsl:attribute name = "ref">
											<xsl:value-of select = "concat('mdref:', @name, 'DomainGroup')"/>
										</xsl:attribute>
									</xsl:element>
								</xsl:if>
							</xsl:element>
						</xsl:if>
						<xsl:apply-templates select = "*" mode = "w3c-schema-ref">
							<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
						</xsl:apply-templates>
						<xsl:call-template name = "build-inherited-properties">
							<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
						</xsl:call-template>
					</xsl:element>
				</xsl:if>
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:other</xsl:text>
					</xsl:attribute>
					<xsl:attribute name = "minOccurs">
						<xsl:value-of select = "number(0)"/>
					</xsl:attribute>
					<xsl:attribute name = "maxOccurs">
						<xsl:value-of select = "number(1)"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:attribute">
				<xsl:attribute name = "name">
					<xsl:text>id</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:ID</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "use">
					<xsl:text>optional</xsl:text>
				</xsl:attribute>
			</xsl:element>
		</xsl:element>
		<xsl:if test = "count(*) >= 1">
			<xsl:call-template name = "buildDomainElement">
				<xsl:with-param name = "suffix" select = "'Group'"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:call-template name = "buildDomainElement"/>
	</xsl:template>
	<xsl:template name = "buildDomainElement">
		<xsl:param name = "suffix"/>
		<xsl:element name = "xsd:element">
			<xsl:attribute name = "name">
				<xsl:value-of select = "concat(@name, 'Domain', $suffix)"/>
			</xsl:attribute>
			<xsl:attribute name = "type">
				<xsl:value-of select = "concat('mddl:', @name, 'Domain.model')"/>
			</xsl:attribute>
			<xsl:element name = "xsd:annotation">
				<xsl:element name = "xsd:appinfo">
					<xsl:element name = "mddl:schema-classification">
						<xsl:text>domain</xsl:text>
					</xsl:element>
				</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "domain" mode = "w3c-schema-ref">
		<xsl:variable name = "refName">
			<xsl:choose>
				<xsl:when test = "@name">
					<xsl:value-of select = "concat(@name, 'Domain')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select = "concat(@ref, 'Domain')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:element name = "xsd:choice">
			<xsl:attribute name = "minOccurs">
				<xsl:value-of select = "number(1)"/>
			</xsl:attribute>
			<xsl:attribute name = "maxOccurs">
				<xsl:value-of select = "number(1)"/>
			</xsl:attribute>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "ref">
					<xsl:value-of select = "concat('mddl:', normalize-space($refName))"/>
				</xsl:attribute>
			</xsl:element>
			<xsl:if test = "$buildLevel = 'full'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:value-of select = "concat('mdref:', normalize-space($refName))"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:if>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "class[@name]" mode = "w3c-schema-define">
		<xsl:element name = "xsd:complexType">
			<xsl:attribute name = "name">
				<xsl:value-of select = "concat(@name, 'Class.model')"/>
			</xsl:attribute>
			<xsl:element name = "xsd:annotation">
				<xsl:element name = "xsd:appinfo">
					<xsl:element name = "mddl:schema-classification">
						<xsl:text>class</xsl:text>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:sequence">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:when</xsl:text>
					</xsl:attribute>
					<xsl:attribute name = "minOccurs">
						<xsl:value-of select = "number(0)"/>
					</xsl:attribute>
					<xsl:attribute name = "maxOccurs">
						<xsl:value-of select = "number(1)"/>
					</xsl:attribute>
				</xsl:element>
				<xsl:if test = "count(*) >= 1">
					<xsl:element name = "xsd:choice">
						<xsl:attribute name = "minOccurs">
							<xsl:value-of select = "number(0)"/>
						</xsl:attribute>
						<xsl:attribute name = "maxOccurs">
							<xsl:text>unbounded</xsl:text>
						</xsl:attribute>
						<xsl:if test = "count(*) >= 1">
							<xsl:element name = "xsd:choice">
								<xsl:attribute name = "minOccurs">
									<xsl:value-of select = "number(1)"/>
								</xsl:attribute>
								<xsl:attribute name = "maxOccurs">
									<xsl:value-of select = "number(1)"/>
								</xsl:attribute>
								<xsl:element name = "xsd:element">
									<xsl:attribute name = "ref">
										<xsl:value-of select = "concat('mddl:', @name, 'ClassGroup')"/>
									</xsl:attribute>
								</xsl:element>
								<xsl:if test = "$buildLevel = 'full'">
									<xsl:element name = "xsd:element">
										<xsl:attribute name = "ref">
											<xsl:value-of select = "concat('mdref:', @name, 'ClassGroup')"/>
										</xsl:attribute>
									</xsl:element>
								</xsl:if>
							</xsl:element>
						</xsl:if>
						<xsl:apply-templates select = "*" mode = "w3c-schema-ref">
							<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
						</xsl:apply-templates>
						<xsl:call-template name = "build-inherited-properties">
							<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
						</xsl:call-template>
					</xsl:element>
				</xsl:if>
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:other</xsl:text>
					</xsl:attribute>
					<xsl:attribute name = "minOccurs">
						<xsl:value-of select = "number(0)"/>
					</xsl:attribute>
					<xsl:attribute name = "maxOccurs">
						<xsl:value-of select = "number(1)"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:attribute">
				<xsl:attribute name = "name">
					<xsl:text>id</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:ID</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "use">
					<xsl:text>optional</xsl:text>
				</xsl:attribute>
			</xsl:element>
		</xsl:element>
		<xsl:if test = "count(*) >= 1">
			<xsl:call-template name = "buildClassElement">
				<xsl:with-param name = "suffix" select = "'Group'"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:call-template name = "buildClassElement"/>
	</xsl:template>
	<xsl:template name = "buildClassElement">
		<xsl:param name = "suffix"/>
		<xsl:element name = "xsd:element">
			<xsl:attribute name = "name">
				<xsl:value-of select = "concat(@name, 'Class', $suffix)"/>
			</xsl:attribute>
			<xsl:attribute name = "type">
				<xsl:value-of select = "concat('mddl:', @name, 'Class.model')"/>
			</xsl:attribute>
			<xsl:element name = "xsd:annotation">
				<xsl:element name = "xsd:appinfo">
					<xsl:element name = "mddl:schema-classification">
						<xsl:text>class</xsl:text>
					</xsl:element>
				</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "class" mode = "w3c-schema-ref">
		<xsl:variable name = "refName">
			<xsl:choose>
				<xsl:when test = "@name">
					<xsl:value-of select = "concat(@name, 'Class')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select = "concat(@ref, 'Class')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:element name = "xsd:choice">
			<xsl:attribute name = "minOccurs">
				<xsl:value-of select = "number(1)"/>
			</xsl:attribute>
			<xsl:attribute name = "maxOccurs">
				<xsl:value-of select = "number(1)"/>
			</xsl:attribute>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "ref">
					<xsl:value-of select = "concat('mddl:', normalize-space($refName))"/>
				</xsl:attribute>
			</xsl:element>
			<xsl:if test = "$buildLevel = 'full'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:value-of select = "concat('mdref:', normalize-space($refName))"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:if>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "subclass[@name]" mode = "w3c-schema-define">
		<xsl:element name = "xsd:complexType">
			<xsl:attribute name = "name">
				<xsl:value-of select = "concat(@name, 'Subclass.model')"/>
			</xsl:attribute>
			<xsl:element name = "xsd:annotation">
				<xsl:element name = "xsd:appinfo">
					<xsl:element name = "mddl:schema-classification">
						<xsl:text>subclass</xsl:text>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:sequence">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:when</xsl:text>
					</xsl:attribute>
					<xsl:attribute name = "minOccurs">
						<xsl:value-of select = "number(0)"/>
					</xsl:attribute>
					<xsl:attribute name = "maxOccurs">
						<xsl:value-of select = "number(1)"/>
					</xsl:attribute>
				</xsl:element>
				<xsl:if test = "count(*) >= 1">
					<xsl:element name = "xsd:choice">
						<xsl:attribute name = "minOccurs">
							<xsl:value-of select = "number(0)"/>
						</xsl:attribute>
						<xsl:attribute name = "maxOccurs">
							<xsl:text>unbounded</xsl:text>
						</xsl:attribute>
						<xsl:if test = "count(*) >= 1">
							<xsl:element name = "xsd:choice">
								<xsl:attribute name = "minOccurs">
									<xsl:value-of select = "number(1)"/>
								</xsl:attribute>
								<xsl:attribute name = "maxOccurs">
									<xsl:value-of select = "number(1)"/>
								</xsl:attribute>
								<xsl:element name = "xsd:element">
									<xsl:attribute name = "ref">
										<xsl:value-of select = "concat('mddl:', @name, 'SubclassGroup')"/>
									</xsl:attribute>
								</xsl:element>
								<xsl:if test = "$buildLevel = 'full'">
									<xsl:element name = "xsd:element">
										<xsl:attribute name = "ref">
											<xsl:value-of select = "concat('mdref:', @name, 'SubclassGroup')"/>
										</xsl:attribute>
									</xsl:element>
								</xsl:if>
							</xsl:element>
						</xsl:if>
						<xsl:apply-templates select = "*" mode = "w3c-schema-ref">
							<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
						</xsl:apply-templates>
						<xsl:call-template name = "build-inherited-properties">
							<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
						</xsl:call-template>
					</xsl:element>
				</xsl:if>
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:other</xsl:text>
					</xsl:attribute>
					<xsl:attribute name = "minOccurs">
						<xsl:value-of select = "number(0)"/>
					</xsl:attribute>
					<xsl:attribute name = "maxOccurs">
						<xsl:value-of select = "number(1)"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:element name = "xsd:attribute">
				<xsl:attribute name = "name">
					<xsl:text>id</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:ID</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "use">
					<xsl:text>optional</xsl:text>
				</xsl:attribute>
			</xsl:element>
		</xsl:element>
		<xsl:if test = "count(*) >= 1">
			<xsl:call-template name = "buildSubclassElement">
				<xsl:with-param name = "suffix" select = "'Group'"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:call-template name = "buildSubclassElement"/>
	</xsl:template>
	<xsl:template name = "buildSubclassElement">
		<xsl:param name = "suffix"/>
		<xsl:element name = "xsd:element">
			<xsl:attribute name = "name">
				<xsl:value-of select = "concat(@name, 'Subclass', $suffix)"/>
			</xsl:attribute>
			<xsl:attribute name = "type">
				<xsl:value-of select = "concat('mddl:', @name, 'Subclass.model')"/>
			</xsl:attribute>
			<xsl:element name = "xsd:annotation">
				<xsl:element name = "xsd:appinfo">
					<xsl:element name = "mddl:schema-classification">
						<xsl:text>subclass</xsl:text>
					</xsl:element>
				</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "subclass" mode = "w3c-schema-ref">
		<xsl:variable name = "refName">
			<xsl:choose>
				<xsl:when test = "@name">
					<xsl:value-of select = "concat(@name, 'Subclass')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select = "concat(@ref, 'Subclass')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:element name = "xsd:choice">
			<xsl:attribute name = "minOccurs">
				<xsl:value-of select = "number(1)"/>
			</xsl:attribute>
			<xsl:attribute name = "maxOccurs">
				<xsl:value-of select = "number(1)"/>
			</xsl:attribute>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "ref">
					<xsl:value-of select = "concat('mddl:', normalize-space($refName))"/>
				</xsl:attribute>
			</xsl:element>
			<xsl:if test = "$buildLevel = 'full'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:value-of select = "concat('mdref:', normalize-space($refName))"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:if>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "property[@name]" mode = "w3c-schema-define">
		<xsl:element name = "xsd:complexType">
			<xsl:attribute name = "name">
				<xsl:value-of select = "concat(@name, '.model')"/>
			</xsl:attribute>
			<xsl:if test = "(@type != 'math') and (@type != 'none') and (@type != 'properties')">
				<xsl:attribute name = "mixed">
					<xsl:text>true</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:element name = "xsd:annotation">
				<xsl:element name = "xsd:appinfo">
					<xsl:element name = "mddl:schema-classification">
						<xsl:text>property</xsl:text>
					</xsl:element>
				</xsl:element>
			</xsl:element>
			<xsl:if test = "@type != 'none'">
				<xsl:element name = "xsd:sequence">
					<xsl:attribute name = "minOccurs">
						<xsl:value-of select = "number(0)"/>
					</xsl:attribute>
					<xsl:attribute name = "maxOccurs">
						<xsl:value-of select = "number(1)"/>
					</xsl:attribute>
					<xsl:element name = "xsd:element">
						<xsl:attribute name = "ref">
							<xsl:text>mddl:when</xsl:text>
						</xsl:attribute>
						<xsl:attribute name = "minOccurs">
							<xsl:value-of select = "number(0)"/>
						</xsl:attribute>
						<xsl:attribute name = "maxOccurs">
							<xsl:value-of select = "number(1)"/>
						</xsl:attribute>
					</xsl:element>
					<xsl:call-template name = "convert-mddl-datatype-to-element">
						<xsl:with-param name = "mddlType" select = "@type"/>
					</xsl:call-template>
					<xsl:if test = "count(*) > count(attribute)">
						<xsl:element name = "xsd:choice">
							<xsl:attribute name = "minOccurs">
								<xsl:value-of select = "number(0)"/>
							</xsl:attribute>
							<xsl:attribute name = "maxOccurs">
								<xsl:text>unbounded</xsl:text>
							</xsl:attribute>
							<xsl:if test = "count(*) >= count(attribute)">
								<xsl:element name = "xsd:choice">
									<xsl:attribute name = "minOccurs">
										<xsl:value-of select = "number(1)"/>
									</xsl:attribute>
									<xsl:attribute name = "maxOccurs">
										<xsl:value-of select = "number(1)"/>
									</xsl:attribute>
									<xsl:element name = "xsd:element">
										<xsl:attribute name = "ref">
											<xsl:value-of select = "concat('mddl:', @name, 'Group')"/>
										</xsl:attribute>
									</xsl:element>
									<xsl:if test = "$buildLevel = 'full'">
										<xsl:element name = "xsd:element">
											<xsl:attribute name = "ref">
												<xsl:value-of select = "concat('mdref:', @name, 'Group')"/>
											</xsl:attribute>
										</xsl:element>
									</xsl:if>
								</xsl:element>
							</xsl:if>
							<xsl:apply-templates select = "*" mode = "w3c-schema-ref">
								<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
							</xsl:apply-templates>
							<xsl:call-template name = "build-inherited-properties">
								<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
							</xsl:call-template>
						</xsl:element>
					</xsl:if>
					<xsl:if test = "not(@final) or (@final != 'true')">
						<xsl:element name = "xsd:element">
							<xsl:attribute name = "ref">
								<xsl:text>mddl:other</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "minOccurs">
								<xsl:value-of select = "number(0)"/>
							</xsl:attribute>
							<xsl:attribute name = "maxOccurs">
								<xsl:value-of select = "number(1)"/>
							</xsl:attribute>
						</xsl:element>
					</xsl:if>
				</xsl:element>
			</xsl:if>
			<xsl:element name = "xsd:attribute">
				<xsl:attribute name = "name">
					<xsl:text>id</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "type">
					<xsl:text>xsd:ID</xsl:text>
				</xsl:attribute>
				<xsl:attribute name = "use">
					<xsl:text>optional</xsl:text>
				</xsl:attribute>
			</xsl:element>
			<xsl:apply-templates select = "attribute" mode = "w3c-schema-local"/>
			<xsl:if test = "@default-scheme">
				<xsl:choose>
					<xsl:when test = "normalize-space(@default-scheme) = ''">
						<xsl:element name = "xsd:attribute">
							<xsl:attribute name = "name">
								<xsl:text>scheme</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "use">
								<xsl:text>required</xsl:text>
							</xsl:attribute>
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name = "xsd:attribute">
							<xsl:attribute name = "name">
								<xsl:text>scheme</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "use">
								<xsl:text>optional</xsl:text>
							</xsl:attribute>
							<xsl:attribute name = "default">
								<xsl:value-of select = "@default-scheme"/>
							</xsl:attribute>
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
		</xsl:element>
		<xsl:if test = "count(*) > count(attribute)">
			<xsl:call-template name = "buildPropertyElement">
				<xsl:with-param name = "suffix" select = "'Group'"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:call-template name = "buildPropertyElement"/>
	</xsl:template>
	<xsl:template name = "buildPropertyElement">
		<xsl:param name = "suffix"/>
		<xsl:element name = "xsd:element">
			<xsl:attribute name = "name">
				<xsl:value-of select = "concat(@name, $suffix)"/>
			</xsl:attribute>
			<xsl:attribute name = "type">
				<xsl:value-of select = "concat('mddl:', @name, '.model')"/>
			</xsl:attribute>
			<xsl:element name = "xsd:annotation">
				<xsl:element name = "xsd:appinfo">
					<xsl:element name = "mddl:schema-classification">
						<xsl:text>property</xsl:text>
					</xsl:element>
				</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "property" mode = "w3c-schema-ref">
		<xsl:variable name = "refName">
			<xsl:choose>
				<xsl:when test = "@name">
					<xsl:value-of select = "@name"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select = "@ref"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:element name = "xsd:choice">
			<xsl:attribute name = "minOccurs">
				<xsl:value-of select = "number(1)"/>
			</xsl:attribute>
			<xsl:attribute name = "maxOccurs">
				<xsl:value-of select = "number(1)"/>
			</xsl:attribute>
			<xsl:element name = "xsd:element">
				<xsl:attribute name = "ref">
					<xsl:value-of select = "concat('mddl:', normalize-space($refName))"/>
				</xsl:attribute>
			</xsl:element>
			<xsl:if test = "$buildLevel = 'full'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:value-of select = "concat('mdref:', normalize-space($refName))"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:if>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "group[@name]" mode = "w3c-schema-define"/>
	<xsl:template match = "group[@ref]" mode = "w3c-schema-ref">
		<xsl:param name = "isInRepeatableChoice" select = "'false'"/>
		<xsl:variable name = "refName" select = "@ref"/>
		<xsl:apply-templates select = "//group[@name = $refName]" mode = "w3c-schema-ref">
			<xsl:with-param name = "isInRepeatableChoice" select = "$isInRepeatableChoice"/>
		</xsl:apply-templates>
	</xsl:template>
	<xsl:template match = "group[not(@ref)]" mode = "w3c-schema-ref">
		<xsl:param name = "isInRepeatableChoice" select = "'false'"/>
		<xsl:choose>
			<xsl:when test = "not(@method) or (@method = 'repeatable-choice')">
				<xsl:choose>
					<xsl:when test = "$isInRepeatableChoice = 'true'">
						<xsl:apply-templates select = "*" mode = "w3c-schema-ref">
							<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
						</xsl:apply-templates>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name = "xsd:choice">
							<xsl:attribute name = "minOccurs">
								<xsl:value-of select = "number(0)"/>
							</xsl:attribute>
							<xsl:attribute name = "maxOccurs">
								<xsl:text>unbounded</xsl:text>
							</xsl:attribute>
							<xsl:apply-templates select = "*" mode = "w3c-schema-ref">
								<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
							</xsl:apply-templates>
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name = "error-message">
					<xsl:with-param name = "message">
						<xsl:text>invalid MDDL method for group:</xsl:text>
						<xsl:value-of select = "$space"/>
						<xsl:value-of select = "@method"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match = "attribute" mode = "w3c-schema-local">
		<xsl:variable name = "type">
			<xsl:call-template name = "convert-mddl-to-xsd-datatype">
				<xsl:with-param name = "mddlType" select = "@type"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:if test = "$type = ''">
			<xsl:call-template name = "error-message">
				<xsl:with-param name = "message">
					<xsl:text>invalid MDDL data type for attribute:</xsl:text>
					<xsl:value-of select = "$space"/>
					<xsl:value-of select = "$type"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:if>
		<xsl:element name = "xsd:attribute">
			<xsl:attribute name = "name">
				<xsl:value-of select = "@name"/>
			</xsl:attribute>
			<xsl:attribute name = "type">
				<xsl:value-of select = "$type"/>
			</xsl:attribute>
			<xsl:choose>
				<xsl:when test = "not(@use) or (@use = 'required')">
					<xsl:attribute name = "use">
						<xsl:text>required</xsl:text>
					</xsl:attribute>
				</xsl:when>
				<xsl:when test = "(@use = 'optional') and @value">
					<xsl:attribute name = "default">
						<xsl:value-of select = "@value"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:when test = "@use = 'optional'">
					<xsl:attribute name = "use">
						<xsl:text>optional</xsl:text>
					</xsl:attribute>
				</xsl:when>
				<xsl:when test = "@use = 'fixed'">
					<xsl:attribute name = "fixed">
						<xsl:value-of select = "@value"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name = "error-message">
						<xsl:with-param name = "message">
							<xsl:text>unrecognised attribute 'use':</xsl:text>
							<xsl:value-of select = "$space"/>
							<xsl:value-of select = "@use"/>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<xsl:template match = "attribute" mode = "w3c-schema-ref"/>
	<xsl:template name = "convert-mddl-to-xsd-datatype">
		<xsl:param name = "mddlType"/>
		<xsl:variable name = "newType">
			<xsl:choose>
				<xsl:when test = "$mddlType = 'string'">
					<xsl:text>xsd:string</xsl:text>
				</xsl:when>
				<xsl:when test = "$mddlType = 'decimal'">
					<xsl:text>xsd:decimal</xsl:text>
				</xsl:when>
				<xsl:when test = "$mddlType = 'percentage'">
					<xsl:text>xsd:decimal</xsl:text>
				</xsl:when>
				<xsl:when test = "$mddlType = 'integer'">
					<xsl:text>xsd:integer</xsl:text>
				</xsl:when>
				<xsl:when test = "$mddlType = 'boolean'">
					<xsl:text>xsd:boolean</xsl:text>
				</xsl:when>
				<xsl:when test = "$mddlType = 'dateTime'">
					<xsl:text>xsd:dateTime</xsl:text>
				</xsl:when>
				<xsl:when test = "$mddlType = 'duration'">
					<xsl:text>xsd:duration</xsl:text>
				</xsl:when>
				<xsl:when test = "$mddlType = 'uri'">
					<xsl:text>xsd:anyURI</xsl:text>
				</xsl:when>
				<xsl:when test = "($mddlType = 'properties') or ($mddlType = 'none')">
					<!-- Just return an empty string. -->
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name = "error-message">
						<xsl:with-param name = "message">
							<xsl:text>unrecognised MDDL data type:</xsl:text>
							<xsl:value-of select = "$space"/>
							<xsl:value-of select = "$mddlType"/>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:value-of select = "normalize-space($newType)"/>
	</xsl:template>
	<xsl:template name = "convert-mddl-datatype-to-element">
		<xsl:param name = "mddlType"/>
		<xsl:choose>
			<xsl:when test = "$mddlType = 'string'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:mdString</xsl:text>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test = "$mddlType = 'decimal'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:mdDecimal</xsl:text>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test = "$mddlType = 'percentage'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:mdPercentage</xsl:text>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test = "$mddlType = 'integer'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:mdInteger</xsl:text>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test = "$mddlType = 'boolean'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:mdBoolean</xsl:text>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test = "$mddlType = 'dateTime'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:mdDateTime</xsl:text>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test = "$mddlType = 'duration'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:mdDuration</xsl:text>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test = "$mddlType = 'uri'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:mdUri</xsl:text>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test = "$mddlType = 'math'">
				<xsl:element name = "xsd:element">
					<xsl:attribute name = "ref">
						<xsl:text>mddl:mdMath</xsl:text>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test = "($mddlType = 'none') or ($mddlType = 'properties')">
				<!-- Do nothing. -->
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name = "error-message">
					<xsl:with-param name = "message">
						<xsl:text>unrecognised MDDL data type:</xsl:text>
						<xsl:value-of select = "$space"/>
						<xsl:value-of select = "$mddlType"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name = "get-direct-properties">
		<!--Returns a list of all the direct properties.  Duplicates, if any, are not removed.-->
		<xsl:variable name = "result">
			<xsl:for-each select = "property[@name]">
				<xsl:text>[</xsl:text>
				<xsl:value-of select = "@name"/>
				<xsl:text>]</xsl:text>
				<xsl:value-of select = "$space"/>
			</xsl:for-each>
			<xsl:for-each select = "property[@ref]">
				<xsl:text>[</xsl:text>
				<xsl:value-of select = "@ref"/>
				<xsl:text>]</xsl:text>
				<xsl:value-of select = "$space"/>
			</xsl:for-each>
			<xsl:for-each select = "group[not(@ref)]">
				<xsl:call-template name = "get-direct-properties"/>
			</xsl:for-each>
			<xsl:for-each select = "group[@ref]">
				<xsl:variable name = "groupName" select = "@ref"/>
				<xsl:for-each select = "//group[@name = $groupName]">
					<xsl:call-template name = "get-direct-properties"/>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:variable>
		<xsl:value-of select = "normalize-space($result)"/>
		<xsl:value-of select = "$space"/>
	</xsl:template>
	<xsl:template name = "get-all-properties">
		<!--Returns a list of all the valid properties (direct & child properties).  Duplicates are not removed, and will normally exist.-->
		<xsl:variable name = "result">
			<xsl:for-each select = "property[@name]">
				<xsl:text>[</xsl:text>
				<xsl:value-of select = "@name"/>
				<xsl:text>]</xsl:text>
				<xsl:value-of select = "$space"/>
				<xsl:call-template name = "get-all-properties"/>
			</xsl:for-each>
			<xsl:for-each select = "subclass[@name]">
				<xsl:call-template name = "get-all-properties"/>
			</xsl:for-each>
			<xsl:for-each select = "class[@name]">
				<xsl:call-template name = "get-all-properties"/>
			</xsl:for-each>
			<xsl:for-each select = "domain[@name]">
				<xsl:call-template name = "get-all-properties"/>
			</xsl:for-each>
			<xsl:for-each select = "property[@ref]">
				<xsl:text>[</xsl:text>
				<xsl:value-of select = "@ref"/>
				<xsl:text>]</xsl:text>
				<xsl:value-of select = "$space"/>
				<xsl:variable name = "propertyName" select = "@ref"/>
				<xsl:for-each select = "key('propertiesByName', $propertyName)">
					<xsl:call-template name = "get-all-properties"/>
				</xsl:for-each>
			</xsl:for-each>
			<xsl:for-each select = "subclass[@ref]">
				<xsl:variable name = "subclassName" select = "@ref"/>
				<xsl:for-each select = "//subclass[@name = $subclassName]">
					<xsl:call-template name = "get-all-properties"/>
				</xsl:for-each>
			</xsl:for-each>
			<xsl:for-each select = "class[@ref]">
				<xsl:variable name = "className" select = "@ref"/>
				<xsl:for-each select = "//class[@name = $className]">
					<xsl:call-template name = "get-all-properties"/>
				</xsl:for-each>
			</xsl:for-each>
			<xsl:for-each select = "domain[@ref]">
				<xsl:variable name = "domainName" select = "@ref"/>
				<xsl:for-each select = "//domain[@name = $domainName]">
					<xsl:call-template name = "get-all-properties"/>
				</xsl:for-each>
			</xsl:for-each>
			<xsl:for-each select = "group[not(@ref)]">
				<xsl:call-template name = "get-all-properties"/>
			</xsl:for-each>
			<xsl:for-each select = "group[@ref]">
				<xsl:variable name = "groupName" select = "@ref"/>
				<xsl:for-each select = "//group[@name = $groupName]">
					<xsl:call-template name = "get-all-properties"/>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:variable>
		<xsl:value-of select = "normalize-space($result)"/>
		<xsl:value-of select = "$space"/>
	</xsl:template>
	<xsl:template name = "build-inherited-properties">
		<xsl:param name = "isInRepeatableChoice" select = "'false'"/>
		<xsl:if test = "$buildLevel = 'full'">
			<xsl:comment>
				<xsl:text>Start of inherited properties ...</xsl:text>
			</xsl:comment>
			<xsl:choose>
				<xsl:when test = "$isInRepeatableChoice = 'true'">
					<xsl:message>
						<xsl:text>  calculating inherited properties for </xsl:text>
						<xsl:value-of select = "name()"/>
						<xsl:text> '</xsl:text>
						<xsl:value-of select = "@name"/>
						<xsl:text>' ...</xsl:text>
					</xsl:message>
					<xsl:variable name = "directProperties">
						<xsl:call-template name = "get-direct-properties"/>
					</xsl:variable>
					<xsl:variable name = "allProperties">
						<xsl:call-template name = "get-all-properties"/>
					</xsl:variable>
					<xsl:for-each select = "//property[@name]">
						<xsl:sort select = "@name"/>
						<xsl:variable name = "thisProperty" select = "concat('[', @name, ']')"/>
						<xsl:if test = "not(contains($directProperties, $thisProperty)) and contains($allProperties, $thisProperty)">
							<xsl:element name = "xsd:choice">
								<xsl:attribute name = "minOccurs">
									<xsl:value-of select = "number(1)"/>
								</xsl:attribute>
								<xsl:attribute name = "maxOccurs">
									<xsl:value-of select = "number(1)"/>
								</xsl:attribute>
								<xsl:element name = "xsd:element">
									<xsl:attribute name = "ref">
										<xsl:value-of select = "concat('mddl:', @name)"/>
									</xsl:attribute>
								</xsl:element>
								<xsl:if test = "$buildLevel = 'full'">
									<xsl:element name = "xsd:element">
										<xsl:attribute name = "ref">
											<xsl:value-of select = "concat('mdref:', @name)"/>
										</xsl:attribute>
									</xsl:element>
								</xsl:if>
							</xsl:element>
						</xsl:if>
					</xsl:for-each>
				</xsl:when>
				<xsl:otherwise>
					<xsl:element name = "xsd:choice">
						<xsl:attribute name = "minOccurs">
							<xsl:value-of select = "number(0)"/>
						</xsl:attribute>
						<xsl:attribute name = "maxOccurs">
							<xsl:text>unbounded</xsl:text>
						</xsl:attribute>
						<xsl:call-template name = "build-inherited-properties">
							<xsl:with-param name = "isInRepeatableChoice" select = "'true'"/>
						</xsl:call-template>
					</xsl:element>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:comment>
				<xsl:text>End of inherited properties</xsl:text>
			</xsl:comment>
		</xsl:if>
	</xsl:template>
</xsl:transform>